;=====i2c lcd test for Ericsson A1018 / Version 1.0======29/06/03==
;iic lcd driver: cheap version of PCF8558
;ra0,ra1     sdata,sclock
;rb0 to rb7led outputs
;internal clock
;standard crystal 4.000 MHz XT - 1us pe instructiune
;Program realizat de Ing. Bergthaller Iulian-Alexandru 
;------------------------------------------------------------
listp=16f84A;f=inhx8m
_CP_OFFequH'3FFF'      ;code protect off
_PWRTE_ONequH'3FFF' ;Power on timer on
_WDT_OFFequH'3FFB';watch dog timer off
_XT_OSCequH'3FFD';crystal oscillator
__CONFIG       _CP_OFF & _PWRTE_ON & _WDT_OFF & _XT_OSC
;------------------------------------------------------------
;      cpu init
statusequ03
portaequ05
portbequ06
count1equ0C
count2equ0D
count3equ0E
transoequ0F
count4equ10
count5equ11
trisaequ85
trisbequ86
#DEFINE sclkporta,1
#DEFINE sdtaporta,0
;------------------------------------------------------------
;      bit init
rp0equ5
wequ0
fequ1
;------------------------------------------------------------
org0
;
;------------------------------------------------------------
initbsfstatus,rp0  ;switch to bank 1
movlw0; porta and portb set to outputs
movwftrisa
movwftrisb
bcfstatus,rp0  ;switch back to bank 0
movlw0
movwfporta
movwfportb
;***************************************************
startmovlw0xFF; led test
movwfportb 
callpause; por time
;***************************************************
;* Lcd init commands                               *
;***************************************************
calliict; i2c start
movlw0x70; device write address (71h for read)
callact; i2c send subroutine
movlw0x0D; all on
callact
callcbild; clear lcd
calliicp; i2c stop
;***************************************************
;* Lcd data                                        *
;***************************************************
calliict; i2c start
movlw0x70; device write address (71h for read)
callact; i2c send subroutine
movlw0x49; line 2
callact
movlw0x27; x offset
callact
movlw0x1F;P
callact
movlw0x05
callact
movlw0x07
callact
movlw0x00
callact
movlw0x1F;H
callact
movlw0x04
callact
movlw0x1F
callact
movlw0x00
callact
movlw0x1F;I
callact
movlw0x00
callact
movlw0x1F;L
callact
movlw0x10
callact
movlw0x10
callact
movlw0x00
callact
movlw0x1F;I
callact
movlw0x00
callact
movlw0x1F;P
callact
movlw0x05
callact
movlw0x07
callact
movlw0x00
callact
movlw0x12;S
callact
movlw0x15
callact
movlw0x09
callact
movlw0x00
callact
calliicp; i2c stop
homagotohoma
;***************************************************
cbildmovlw0x05
movwfcount5
bcfsdta
lineemovlw0x65
movwfcount4
wdhmovlw0x08
movwfcount3
wbitbcfsclk
callpause
bsfsclk
callpause
bcfsclk
decfszcount3,f
gotowbit
callackp
decfszcount4,f
goto wdh 
decfszcount5,f
goto linee
retlw00 
;***************************************************
actmovwftranso; iic data transmission 
calloled
movlw0x08
movwfcount3
vbitbcfsclk
callpause
btfsctranso,7
bsfsdta
btfsstranso,7
bcfsdta
callpause
bsfsclk
callpause
bcfsclk
callpause
rlftranso,f
decfszcount3,f
gotovbit
callackp
retlw00
;***************************************************
iicpbcfsdta; stop condition module
callpause
bsfsclk
callpause
bsfsdta; stop command
callpause
bcfsclk
callpause
retlw00
;***************************************************
iictbsfsdta; start condition module 
bsfsclk
callpause
bcfsdta; start command
callpause
bcfsclk
callpause
retlw00
;***************************************************
ackpbsfstatus,rp0  ;switch to bank 1
movlw0xFF; porta set to input
movwftrisa
bcfstatus,rp0  ;switch back to bank 0
bsfsclk; one clock step for acknowledge (no read data)
callpause
bcfsclk
bsfstatus,rp0  ;switch to bank 1
movlw0; porta set to output
movwftrisa
bcfstatus,rp0  ;switch back to bank 0
movwfporta
retlw00
;***************************************************
oledcallhalta; iic data before transmission displayed on portb
movlw0x00
movwfportb 
movftranso,w
movwfportb
callhalta
movlw0x00
movwfportb
retlw00
;***************************************************
pausemovlw0x10
movwfcount1
d1decfszcount1,f
goto d1
 retlw00
;***************************************************
haltamovlw0x02; cca. 585ms delay
movwfcount3
r3movlw0x7F
movwfcount1
r1movlw0xFF  
movwfcount2
r2decfszcount2,f
goto r2
decfszcount1,f
goto r1
decfszcount3,f    
gotor3          
retlw00
;------------------------------------------------------------
end
;============================================================